#! /usr/bin/env python
#  EIciRNA.py
#  python EIciRNA.py beds.fa ref.gtf map.bam output_name

from sys import argv

def repeat_remove(a):
    x=[]
    for i in range(len(a)):
        if a[i] not in x:
            x.append(a[i])
    return x

def count_number(a):
    y=[]
    x=repeat_remove(a)
    for i in  range(len(x)):
        b=a.count(x[i])
        y.append(x[i][:-1]+'\t'+str(b)+'\n')
    return y

def EI_annotated(line,seq):
    comp=line.split('\t')
    x=[]
    for i in range(len(seq)):
        exon=seq[i].split('\t')
        if comp[0]==exon[0]:
            if abs(int(comp[1])-int(exon[3]))<5 and int(comp[2])>int(exon[4]):
                   x.append('\t'.join(comp[:4])+'\t'+str(int(exon[4])-int(exon[3]))+'\n')
            if abs(int(comp[2])-int(exon[4]))<5 and int(comp[1])<int(exon[3]):
                   x.append('\t'.join(comp[:4])+'\t'+str(int(exon[3])-int(comp[1]))+'\n')
    return repeat_remove(x)

def EI_map(line):
    y=[]
    for i in range(len(line)):
        comp=line[i].split('\t')
        y.append(comp[0]+'\t'+comp[1]+'\t'+str(int(comp[1])+line[i].count('I'))+'\n')
    return y

def EI_detected(line,seq1):
    x=seq=[]
    comp=line.split('\t')
    seq=EI_map(seq1)
    for i in range(len(seq)):
        inf=seq[i].split('\t')
        if comp[3]==inf[0]:
            if int(comp[4][:-1])>int(inf[1]) and int(comp[4][:-1])<int(inf[2][:-1]):
                x.append(inf[0]+'\n')
    return x

f1=open(argv[1])
f2=open(argv[2])
f3=open(argv[3])
out = open(argv[4],'w')
seq=f2.readlines()
inf=f3.readlines()
EI=final=EIciRNA=[]
out.write('EIciRNA_name\tExon-Intron count\n')
while True:
    line=f1.readline()
    if len(line)==0:
        break
    EI=EI+EI_annotated(line,seq)
for i in range(len(EI)):
    final=final+EI_detected(EI[i],inf)
EIciRNA=count_number(final)
for i in range(len(EIciRNA)):
    out.write(EIciRNA[i])
        
f1.close()
f2.close()
f3.close()
out.close()	
